#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
 
typedef long long LL;
typedef vector<int> VI;
typedef vector<LL> VLL;
typedef pair<LL,int> PLI;
 
#define pb push_back
#define sz size()
#define mp make_pair
#define cl clear()
#define all(a) (a).begin(),(a).end()
#define X first
#define Y second
 
const int maxTST = 40;
const int maxX = 60;
const int maxA = 170000;
const int maxD = 10; // max( tau(x) : x < maxX ) here tau(48)=10
 
int gcd(int a,int b)
{
	LL c;
	while(b) c=a%b,a=b,b=c;
	return a;
}
 
void operator+=(VLL &a,const VLL &b)
{
	for(int i=a.sz;i--;)
		a[i]+=b[i];
}
 
VLL operator/(const VLL &a,LL b)
{
	VLL c=a;
	for(int i=a.sz;i--;)
		c[i]/=b;
	return c;
}
 
void merge(PLI *a,int n,PLI *b,int m,PLI *c,int &k)
{
	int i,j,s;
	for(i=j=k=0;i<n && j<m;)
	{
		LL dif=a[i].X-b[j].X;
		if(dif<0) c[k++]=a[i++]; else
		if(dif>0) c[k++]=b[j++]; else
		{
			if(s=a[i].Y+b[j].Y)
				c[k++]=mp(a[i].X,s);
			i++,j++;
		}
	}
	for(;i<n;i++) c[k++]=a[i];
	for(;j<m;j++) c[k++]=b[j];
}
 
PLI a[maxA],A[2*maxD-2][maxA];
int len,Alen[2*maxD-2];
 
VLL nondiv_count(const VI &p,VLL m)
{
	int i,j,k,L;
	LL M=0;
	for(i=0;i<m.sz;i++)
		M=max(M,m[i]);
	a[0]=mp(1,1);
	len=1;
	for(int it=0;it<p.sz;it++)
	{
		int q=p[it];
		int mult[maxX];
		int ind[maxX];
		int cnt=0;
		for(k=0;k<=q;k++)
		{
			mult[k]=q/gcd(k,q);
			if(k && q%k==0) ind[k]=cnt++;
		}
		for(i=0;i<cnt;i++)
			Alen[i]=0;
		int old=len;
		for(i=0;i<old;i++)
		{
			LL cur=a[i].X;
			int w=mult[cur%q];
			if(w>1)
			{
				A[0][Alen[0]++]=a[i];
				if(cur*w<=M)
				{
					int h=ind[w];
					A[h][Alen[h]++]=mp(cur*w,-a[i].Y);
				}
			}
		}
		set<pair<int,int> > sL;
		for(i=0;i<cnt;i++)
		{
			L=Alen[i];
			if(L>0) sL.insert(mp(L,i));
		}
		if(sL.sz==0) {
			len=0;
		} else {
			if(sL.sz==1) {
				i=sL.begin()->Y;
				len=sL.begin()->X;
				for(j=0;j<len;j++)
					a[j]=A[i][j];
			} else {
				for(;sL.sz>1;)
				{
					PLI tmp=*(sL.begin());
					i=tmp.Y;
					sL.erase(sL.begin());
					j=sL.begin()->Y;
					sL.erase(sL.begin());
					if(sL.sz==0) {
						merge(A[i],Alen[i],A[j],Alen[j],a,len);
					} else {
						merge(A[i],Alen[i],A[j],Alen[j],A[cnt],Alen[cnt]);
						sL.insert(mp(Alen[cnt],cnt));
						cnt++;
					}
				}
			}
		}
	}
	VLL ans(m.sz,0);
	for(i=0;i<m.sz;i++)
	{
		LL tmp=0;
		for(j=0;j<len;j++)
			tmp+=a[j].Y*(m[i]/a[j].X);
		ans[i]=tmp;
	}
	return ans;
}
 
VLL calc(VLL b,int x)
{
	int i,j,k;
	VLL ans(b.sz,0);
	vector<pair<pair<VI,int>,VLL> > save;
	for(k=1;k<x;k++)
	{
		int xk=x/gcd(x,k);
		VI v;
		for(j=k+1;j<x;j++)
			v.pb(j/gcd(j,k*xk));
		sort(all(v));
		VI u;
		for(i=0;i<v.sz;i++)
		{
			for(j=0;j<i && v[i]%v[j];j++);
			if(j==i) u.pb(v[j]);
		}
		int mint=0;
		pair<VI,int> tmp=mp(u,xk);
		for(j=0;j<save.sz && save[j].X!=tmp;j++);
		VLL cnt;
		if(j<save.sz) {
			cnt=save[j].Y;
		} else {
			cnt=nondiv_count(u,b/xk);
			save.pb(mp(mp(u,xk),cnt));
		}
		ans+=cnt;
	}
	return ans;
}
 
struct test
{
	LL b;
	int x;
	int ind;
	test(){}
	test(LL b_,int x_,int ind_){b=b_,x=x_,ind=ind_;}
	bool operator<(const test &a) const
	{
		if(x!=a.x) return x<a.x;
		if(b!=a.b) return b<a.b;
		return ind<a.ind;
	}
};
 
int main()
{
	int TST;
	scanf("%d",&TST);
	test data[maxTST];
	LL answers[maxTST];
	int i,j;
	for(i=0;i<TST;i++)
	{
		LL b;
		int x;
		scanf("%lld %d",&b,&x);
		data[i]=test(b,x,i);
	}
	sort(data,data+TST);
	for(i=0;i<TST;i=j)
	{
		int x=data[i].x;
		VLL b;
		for(j=i;j<TST && data[j].x==x;j++)
			b.pb(data[j].b);
		VLL ans=calc(b,x);
		int k=0;
		for(j=i;j<TST && data[j].x==x;j++)
			answers[data[j].ind]=ans[k++];
	}
	for(i=0;i<TST;i++)
		printf("%lld\n",answers[i]);
	return 0;
}